package generated.copycardMehrereTerminals.javacard.copycard;

import javacard.framework.*;

/**
 * Generated Smartcard for CopycardMehrereTerminals model
 */
public class Copycard extends SimpleComm {

	public short balance;
	public Secret passphrase;
	public Nonce challenge;
	public byte statecard;

	/**
	 * Constructor
	 */
	public Copycard() {
		balance = 0;
		passphrase = new Secret();
		challenge = new Nonce();
		statecard = StateCard.APPLET_UNINITIALIZED;
	}

	public void appletInitialization(byte[] buf, short offset) {
		if (statecard != StateCard.APPLET_UNINITIALIZED)
			stop();
		Coding.getInstance().decodeCopycard(buf, offset, this);
	}

	/**
	 * This init method is used for testcases to quickly initialize a card
	 */
	public Copycard init(short balance, Secret passphrase, byte statecard) {

		this.balance = balance;
		this.passphrase = passphrase;
		this.statecard = statecard;

		challenge = new Nonce();

		return this;
	}

	public Copycard init() {
		balance = 0;
		passphrase = new Secret();
		challenge = new Nonce();
		statecard = StateCard.IDLE_CARD;

		return this;
	}

	/**
	 * process-method, is called from SimpleComm when a message arrives
	 * 
	 * @param inmsg message to process
	 */
	public void process(Message inmsg) {
		if (statecard == StateCard.APPLET_UNINITIALIZED)
			stop();

		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.REQUESTBALANCE :
				processRequestBalance((RequestBalance) inmsg);
				break;
			case Code.PAY :
				processPay((Pay) inmsg);
				break;
			case Code.AUTHENTICATE :
				processAuthenticate((Authenticate) inmsg);
				break;
			case Code.LOAD :
				processLoad((Load) inmsg);
				break;
			//Unknown Message
			default :
				stop();
		}

		currentGate.callConstraints();
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processRequestBalance(RequestBalance inmsg) {

		statecard = StateCard.IDLE_CARD;
		sendMsg(Store.newResRequestBalance(balance));
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processPay(Pay inmsg) {
		short value = inmsg.amount;
		Nonce termchallenge = inmsg.terminalchallenge;
		statecard = StateCard.IDLE_CARD;
		if (((value <= (short) 0) || (Math.minus(balance, value) < (short) 0))) {
			stop();
		} else {
			balance = Math.minus(balance, value);
			AuthData tmp = Store.newAuthData(Constants.PAY, passphrase,
					termchallenge, value);
			HashedData authhashed = HashedData.hash(tmp);
			sendMsg(Store.newResPay(authhashed));
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processAuthenticate(Authenticate inmsg) {

		challenge.copy(Nonce.generateNonce());
		statecard = StateCard.EXPLOAD;
		sendMsg(Store.newResAuthenticate(challenge));
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processLoad(Load inmsg) {
		short value = inmsg.amount;
		HashedData hashedauth = inmsg.authterminal;
		if (statecard == StateCard.EXPLOAD) {
			statecard = StateCard.IDLE_CARD;
			AuthData ad = Store.newAuthData(Constants.LOAD, passphrase,
					challenge, value);
			if (((hashedauth.equals(HashedData.hash(ad)) && (value > (short) 0)) && (Math
					.plus(value, balance) <= (short) 20000))) {
				balance = Math.plus(balance, value);
				sendMsg(Store.newResLoad(balance));
			} else {
				stop();
			}
		} else {
			stop();
		}
	}

}
