package generated.copycardMehrereTerminals.javacard.copycard;

import javacard.security.RandomData;
import javacard.framework.*;
/**
 * generated Nonce class for random numbers
 */

public class Nonce implements Codeable, HashData {

	public byte[] nonce;

	private static RandomData rd;

	public Nonce() {

		if (rd == null)
			rd = RandomData.getInstance(RandomData.ALG_SECURE_RANDOM);
		nonce = new byte[Store.LENGTHOFNONCE];
		rd.generateData(nonce, (short) 0, (short) nonce.length);

	}

	public Nonce(byte[] nonce) {
		this.nonce = nonce;
	}

	public void copy(Nonce o) {

		Arrays.copy(o.nonce, nonce);

	}

	public byte getCode() {
		return Code.NONCE;
	}

	public boolean equals(Nonce other) {
		return Arrays.equals(nonce, other.nonce);
	}

	public static Nonce generateNonce() {

		if (rd == null)
			rd = RandomData.getInstance(RandomData.ALG_SECURE_RANDOM);
		return Store.newNonce().instGenerateNonce();

	}

	public Nonce instGenerateNonce() {

		rd.generateData(nonce, (short) 0, (short) nonce.length);

		return this;
	}

}
