package generated.copycardMehrereTerminals.terminal.copyingMachine;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import swt.util.ByteArray;
import java.security.Security;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
@XmlAccessorType(XmlAccessType.FIELD)
public class HashedData implements Codeable, HashData {

	public final static short HASHLENGTH = 20;
	public byte[] hashed;

	public final static String cryptProvider = "BC";

	private byte[] tohash;

	public HashedData() {

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());
		tohash = new byte[LengthConstants.COMPUTEDHASHDATALENGTH];

		hashed = new byte[HASHLENGTH];
	}

	public byte[] getHashed() {
		return hashed;
	}

	public void setHashed(byte[] hashed) {
		ByteArray.copy(hashed, 0, this.hashed, 0, (short) this.hashed.length);
	}

	public void copy(HashedData from) {

		this.hashed = from.getHashed().clone();

	}

	public byte getCode() {
		return Code.HASHEDDATA;
	}

	public boolean equals(HashedData other) {
		return Arrays.equals(hashed, other.hashed);
	}

	public static HashedData hash(HashData h) throws Exception {

		return (new HashedData()).insthash(h);

	}

	public HashedData insthash(HashData h) throws Exception {
		Coding c = Coding.getInstance();
		c.encode(h, tohash);

		MessageDigest md = MessageDigest.getInstance("SHA1", cryptProvider);
		hashed = md
				.digest(ByteArray.subarray(tohash, 0, c.getEncodingLength()));

		return this;
	}

}
