package generated.copycardMehrereTerminals.terminal.depositMachine;

//import swt.simulation.SmartCardSimulation;
import swt.terminal.HandleResult;
import swt.util.ByteArray;
import swt.util.HexString;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReader;
import de.uniaugsburg.swt.javacard.terminalinterface.SWTReaderException;
import javax.xml.ws.BindingProvider;

public class DepositMachine {

	private Secret passphrase;

	private int money;

	private byte stateterminal;

	private int amountToLoad;

	private Userinterface userinterface;
	public void setUserinterface(Userinterface u) {
		this.userinterface = u;
	}

	// saved prev message
	public byte[] prevMsg;
	public Userinputs prevUMsg;

	public final Gate dummyGate = new Gate() {
		@Override
		public void callConstraints() {
			/* do nothing */
		}

		@Override
		public byte[] transmit(DepositMachine terminal, byte[] apdu, int port)
				throws TerminalException, SWTReaderException {
			return terminal.transmit(apdu, port);
		}

		@Override
		public void finishProtocol(DepositMachine terminal) {
			/* do nothing */
		}

	};
	public Gate currentGate = dummyGate;

	/**
	 * Resets the current gate to a default dummy gate
	 */
	public void resetGate() {
		currentGate = dummyGate;
	}

	/**
	 * Sets the current gate
	 */
	public void setGate(Gate gate) {
		currentGate = gate;
	}

	public DepositMachine() throws java.lang.Exception {

		passphrase = new Secret();
		money = 0;
		stateterminal = StateTerminal.IDLE_TERMINAL;
		amountToLoad = 0;

	}

	public DepositMachine(Secret passphrase, byte stateterminal)
			throws java.lang.Exception {

		this.passphrase = passphrase;
		this.stateterminal = stateterminal;

		money = 0;
		amountToLoad = 0;

	}

	private void sendMsg(Message msg) {

		currentGate.callConstraints();
		userinterface.send((Userinputs) msg);

	}

	private void sendMsg(Message msg, int port) throws java.lang.Exception {

		sendMsg(msg, port, false, false);

	}
	private void sendMsg(Message msg, int port, Boolean openSessionBeforeSend,
			Boolean closeSessionAfterReceive) throws java.lang.Exception {

		currentGate.callConstraints();

		Message response;

		switch (port) {
			case Ports.DepositMachine2Copycard_default :
				response = sendCardMsg(msg, port);
				if (response != null)
					processMessage(response);
				break;

			default :
				stop();
		}
	}

	private Message sendCardMsg(Message msg, int port)
			throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode((Codeable) msg, encMsg);
		encMsg = ByteArray.subarray(encMsg, 0, encMsgLen);
		byte[] apdu = ByteArray.append(new byte[]{0, 2, 0, 0, 0}, encMsg);
		byte[] response = currentGate.transmit(this, apdu, port);

		if (response.length == 2) {
			if (!(response[0] == (byte) 0x90 && response[1] == (byte) 0x00))
				throw new TerminalException("Cardexception: "
						+ HandleResult.interpretSW(response));
			return null;
		} else {
			prevMsg = response;

			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(response);
			return (Message) cResponse;
		}
	}

	/**
	 * Processes a raw data stream by trying to decode data to Message.
	 * Needed for testcases.
	 * @param data
	 */
	public void processRawMessage(byte[] data) {
		prevMsg = data;
		try {
			Coding.getInstance().decodeInit();
			Codeable cResponse = Coding.getInstance().decode(data);
			processMessage((Message) cResponse);
		} catch (java.lang.Exception e) {
			System.err.println("Failed decoding data in processRawMessage");
		}

	}

	private void processMessage(Message inmsg) throws java.lang.Exception {
		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.UINSERTMONEY :
				processUInsertMoney((UInsertMoney) inmsg);
				break;
			case Code.RESAUTHENTICATE :
				processResAuthenticate((ResAuthenticate) inmsg);
				break;
			case Code.RESLOAD :
				processResLoad((ResLoad) inmsg);
				break;
			case Code.UREQUESTBALANCE :
				processURequestBalance((URequestBalance) inmsg);
				break;
			case Code.RESREQUESTBALANCE :
				processResRequestBalance((ResRequestBalance) inmsg);
				break;
			default :
				stop();
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	public void process(Message msg) throws TerminalException {
		currentGate.callConstraints();

		try {
			if (msg instanceof Userinputs)
				prevUMsg = (Userinputs) msg;
			processMessage(msg);
		} catch (java.lang.Exception e) {
			// e.printStackTrace();
			if (e instanceof TerminalException)
				throw (TerminalException) e;
			else
				throw new TerminalException(
						"Error when calling process method: " + e);
		}

		currentGate.callConstraints();
		currentGate.finishProtocol(this);
	}

	private final static int MAX_SPLIT_LENGTH = 50;
	private final static int MAX_APDU_LENGTH = 254;
	private final static int APDU_HEADER_LENGTH = 5;
	private final static int APDU_DATA_LENTH = MAX_APDU_LENGTH
			- APDU_HEADER_LENGTH;
	private SWTReader[] reader = new SWTReader[2];

	public void initReader(SWTReader reader, int port) {
		this.reader[port] = reader;
	}

	public byte[] encode(Codeable c) throws java.lang.Exception {
		byte[] encMsg = new byte[LengthConstants.MAX_ENCODING_LENGTH_MESSAGES];
		short encMsgLen = Coding.getInstance().encode(c, encMsg);
		return ByteArray.subarray(encMsg, 0, encMsgLen);
	}

	public byte[] transmit(byte[] apdu, int port) throws TerminalException,
			SWTReaderException {
		byte[] received = null;
		if (apdu.length <= MAX_APDU_LENGTH) {
			apdu[4] = (byte) (apdu.length - 5);
			received = reader[port].transmit(apdu);
			if (received.length == 2)
				return received;
			received = ByteArray.subarray(received, 0, received.length - 2);
		} else {
			byte[] splittedApdu;
			byte[] apduHeader = ByteArray.subarray(apdu, 0, APDU_HEADER_LENGTH);
			apdu = ByteArray.subarray(apdu, APDU_HEADER_LENGTH);
			int splitCount = apdu.length / APDU_DATA_LENTH;
			if (apdu.length % APDU_DATA_LENTH != 0)
				splitCount++;
			for (int i = 0; i < splitCount; i++) {
				if (i == splitCount - 1) {
					splittedApdu = ByteArray
							.subarray(apdu, i * APDU_DATA_LENTH);
					apduHeader[2] = (byte) 0;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (received.length == 2)
						return received;
					received = ByteArray.subarray(received, 0,
							received.length - 2);
				} else {
					splittedApdu = ByteArray.subarray(apdu,
							i * APDU_DATA_LENTH, APDU_DATA_LENTH);
					apduHeader[2] = (byte) 1;
					apduHeader[4] = (byte) splittedApdu.length;
					splittedApdu = ByteArray.append(apduHeader, splittedApdu);
					received = reader[port].transmit(splittedApdu);
					if (!(received[0] == (byte) 0x90 && received[1] == (byte) 0x00)) {
						throw new TerminalException(
								"Bad answer from card: part of a long APDU was not answered with OK (0x9000).");
					}
				}
			}
		}

		for (int i = 0; i < MAX_SPLIT_LENGTH; i++) {
			if (received[0] == 0) {
				received = ByteArray.subarray(received, 1);
				return received;
			} else if (received[0] == 1) {
				received = ByteArray.subarray(received, 1);
				byte[] getMore = new byte[]{0, 6, 0, 0, 0, 1, 1};
				byte[] temp_received = reader[port].transmit(getMore);

				temp_received = ByteArray.subarray(temp_received, 0,
						temp_received.length - 2);
				received = ByteArray.append(temp_received[0], received);
				temp_received = ByteArray.subarray(temp_received, 1);
				received = ByteArray.append(received, temp_received);
			} else
				throw new TerminalException(
						"Bad answer from card: answer to a long APDU must begin with 0 or 1.");
		}
		return received;
	}

	/**
	 * This method initializes the card with the given parameters that correspond 
	 * to the card attributes. A null value will be ignored by the card.
	 * @throws Exception
	 */
	public void initCard_Copycard(int port, int balance, Secret passphrase,
			byte statecard) throws java.lang.Exception {
		byte cardCode = Code.COPYCARD;
		byte[] apdu = {0, 4, 0, 0, 0, cardCode};
		apdu = ByteArray.append(
				apdu,
				ByteArray.append(Code.SHORT,
						ByteArray.toByteArray((short) balance)));
		apdu = ByteArray.append(apdu, (passphrase != null)
				? encode(passphrase)
				: new byte[]{Code.IGNORE});

		apdu = ByteArray.append(apdu, new byte[]{Code.BYTE, statecard});
		transmit(apdu, port);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processUInsertMoney(UInsertMoney inmsg)
			throws java.lang.Exception {
		int val = inmsg.getValue();
		if ((val > 0)) {
			setAmountToLoad(val);
			setMoney((money + amountToLoad));
			setStateterminal(StateTerminal.EXPRESAUTH);
			sendMsg(new Authenticate(), Ports.DepositMachine2Copycard_default);
		} else {
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processResAuthenticate(ResAuthenticate inmsg)
			throws java.lang.Exception {
		Nonce challenge = inmsg.getCardletchallenge();
		if (stateterminal == StateTerminal.EXPRESAUTH) {
			setStateterminal(StateTerminal.EXPRESLOAD);
			AuthData tmp = new AuthData(Constants.LOAD, passphrase, challenge,
					amountToLoad);
			HashedData hashedauth = HashedData.hash(tmp);
			sendMsg(new Load(amountToLoad, hashedauth),
					Ports.DepositMachine2Copycard_default);
		} else {
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processResLoad(ResLoad inmsg) throws java.lang.Exception {
		int balance = inmsg.getBalance();
		if (stateterminal == StateTerminal.EXPRESLOAD) {
			setStateterminal(StateTerminal.IDLE_TERMINAL);
			sendMsg(new UResLoad(balance, amountToLoad));
		} else {
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processURequestBalance(URequestBalance inmsg)
			throws java.lang.Exception {

		setStateterminal(StateTerminal.IDLE_TERMINAL);
		sendMsg(new RequestBalance(), Ports.DepositMachine2Copycard_default);
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	private void processResRequestBalance(ResRequestBalance inmsg)
			throws java.lang.Exception {
		int balance = inmsg.getBalance();
		sendMsg(new UShowBalance(balance));
	}

	public Secret getPassphrase() {
		return passphrase;
	}

	public int getMoney() {
		return money;
	}

	public byte getStateterminal() {
		return stateterminal;
	}

	public int getAmountToLoad() {
		return amountToLoad;
	}

	public void setPassphrase(Secret passphrase) {
		this.passphrase = passphrase;
	}
	public void setMoney(int money) {
		this.money = money;
	}

	public void setStateterminal(byte stateterminal) {
		this.stateterminal = stateterminal;
	}

	public void setAmountToLoad(int amountToLoad) {
		this.amountToLoad = amountToLoad;
	}

	protected void stop() throws TerminalException {
		currentGate.callConstraints();
		throw new TerminalException("DepositMachine");
	}

}
